Workaround changed LVM behaviour
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_MAN = $(top_srcdir)/autotools/check-man
25 CHECK_VERSION = $(top_srcdir)/autotools/check-version
26 CHECK_NEWS = $(top_srcdir)/autotools/check-news
27 DOCPP = $(top_srcdir)/autotools/docpp
28 REPLACE_VARS_SED = autotools/replace_vars.sed
29 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
30
31 # Note: these are automake-specific variables, and must be named after
32 # the directory + 'dir' suffix
33 clientdir = $(pkgpythondir)/client
34 hypervisordir = $(pkgpythondir)/hypervisor
35 httpdir = $(pkgpythondir)/http
36 masterddir = $(pkgpythondir)/masterd
37 confddir = $(pkgpythondir)/confd
38 rapidir = $(pkgpythondir)/rapi
39 serverdir = $(pkgpythondir)/server
40 watcherdir = $(pkgpythondir)/watcher
41 impexpddir = $(pkgpythondir)/impexpd
42 utilsdir = $(pkgpythondir)/utils
43 toolsdir = $(pkglibdir)/tools
44 iallocatorsdir = $(pkglibdir)/iallocators
45 pytoolsdir = $(pkgpythondir)/tools
46 docdir = $(datadir)/doc/$(PACKAGE)
47 myexeclibdir = $(pkglibdir)
48
49 # Delete output file if an error occurred while building it
50 .DELETE_ON_ERROR:
51
52 HTOOLS_DIRS = \
53         htools \
54         htools/Ganeti \
55         htools/Ganeti/HTools \
56         htools/Ganeti/HTools/Program
57
58 DIRS = \
59         autotools \
60         daemons \
61         devel \
62         doc \
63         doc/examples \
64         doc/examples/hooks \
65         doc/examples/gnt-debug \
66         $(HTOOLS_DIRS) \
67         lib \
68         lib/client \
69         lib/build \
70         lib/confd \
71         lib/http \
72         lib/hypervisor \
73         lib/impexpd \
74         lib/masterd \
75         lib/rapi \
76         lib/server \
77         lib/tools \
78         lib/utils \
79         lib/watcher \
80         man \
81         qa \
82         test \
83         test/data \
84         tools
85
86 BUILDTIME_DIR_AUTOCREATE = \
87         scripts \
88         $(APIDOC_DIR) \
89         $(APIDOC_PY_DIR) \
90         $(APIDOC_HS_DIR) \
91         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
92         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
93         $(COVERAGE_DIR) \
94         $(COVERAGE_PY_DIR) \
95         $(COVERAGE_HS_DIR) \
96         .hpc
97
98 BUILDTIME_DIRS = \
99         $(BUILDTIME_DIR_AUTOCREATE) \
100         doc/html
101
102 DIRCHECK_EXCLUDE = \
103         $(BUILDTIME_DIRS) \
104         ganeti-[0-9]*.[0-9]*.[0-9]* \
105         doc/html/_*
106
107 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
108
109 # some helper vars
110 COVERAGE_DIR = doc/coverage
111 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
112 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
113 APIDOC_DIR = doc/api
114 APIDOC_PY_DIR = $(APIDOC_DIR)/py
115 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
116
117 MAINTAINERCLEANFILES = \
118         $(docpng) \
119         $(maninput) \
120         doc/install-quick.rst \
121         doc/news.rst \
122         doc/upgrade.rst \
123         vcs-version
124
125 maintainer-clean-local:
126         rm -rf $(BUILDTIME_DIRS)
127
128 CLEANFILES = \
129         $(addsuffix /*.py[co],$(DIRS)) \
130         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
131         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
132         $(all_dirfiles) \
133         $(PYTHON_BOOTSTRAP) \
134         epydoc.conf \
135         autotools/replace_vars.sed \
136         daemons/daemon-util \
137         daemons/ganeti-cleaner \
138         devel/upload \
139         doc/examples/bash_completion \
140         doc/examples/ganeti.initd \
141         doc/examples/ganeti-kvm-poweroff.initd \
142         doc/examples/ganeti.cron \
143         doc/examples/gnt-config-backup \
144         doc/examples/hooks/ipsec \
145         $(man_MANS) \
146         $(manhtml) \
147         tools/kvm-ifup \
148         stamp-srclinks \
149         $(nodist_pkgpython_PYTHON) \
150         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
151         .hpc/*.mix htools/*.tix \
152         doc/hs-lint.html
153
154 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
155 # it'll cause the target to rebuild every time.
156 BUILT_SOURCES = \
157         ganeti \
158         stamp-srclinks \
159         $(all_dirfiles) \
160         $(PYTHON_BOOTSTRAP) \
161         $(BUILT_PYTHON_SOURCES)
162
163 BUILT_PYTHON_SOURCES = \
164         lib/_autoconf.py \
165         lib/_vcsversion.py
166
167 nodist_pkgpython_PYTHON = \
168         $(BUILT_PYTHON_SOURCES)
169
170 noinst_PYTHON = \
171         lib/build/__init__.py \
172         lib/build/sphinx_ext.py
173
174 pkgpython_PYTHON = \
175         lib/__init__.py \
176         lib/asyncnotifier.py \
177         lib/backend.py \
178         lib/bdev.py \
179         lib/bootstrap.py \
180         lib/cli.py \
181         lib/cmdlib.py \
182         lib/compat.py \
183         lib/config.py \
184         lib/constants.py \
185         lib/daemon.py \
186         lib/errors.py \
187         lib/ht.py \
188         lib/jqueue.py \
189         lib/jstore.py \
190         lib/locking.py \
191         lib/luxi.py \
192         lib/mcpu.py \
193         lib/netutils.py \
194         lib/objects.py \
195         lib/opcodes.py \
196         lib/qlang.py \
197         lib/query.py \
198         lib/rpc.py \
199         lib/runtime.py \
200         lib/serializer.py \
201         lib/ssconf.py \
202         lib/ssh.py \
203         lib/storage.py \
204         lib/uidpool.py \
205         lib/workerpool.py
206
207 client_PYTHON = \
208         lib/client/__init__.py \
209         lib/client/gnt_backup.py \
210         lib/client/gnt_cluster.py \
211         lib/client/gnt_debug.py \
212         lib/client/gnt_group.py \
213         lib/client/gnt_instance.py \
214         lib/client/gnt_job.py \
215         lib/client/gnt_node.py \
216         lib/client/gnt_os.py
217
218 hypervisor_PYTHON = \
219         lib/hypervisor/__init__.py \
220         lib/hypervisor/hv_base.py \
221         lib/hypervisor/hv_chroot.py \
222         lib/hypervisor/hv_fake.py \
223         lib/hypervisor/hv_kvm.py \
224         lib/hypervisor/hv_lxc.py \
225         lib/hypervisor/hv_xen.py
226
227 rapi_PYTHON = \
228         lib/rapi/__init__.py \
229         lib/rapi/baserlib.py \
230         lib/rapi/client.py \
231         lib/rapi/client_utils.py \
232         lib/rapi/connector.py \
233         lib/rapi/rlib2.py
234
235 http_PYTHON = \
236         lib/http/__init__.py \
237         lib/http/auth.py \
238         lib/http/client.py \
239         lib/http/server.py
240
241 confd_PYTHON = \
242         lib/confd/__init__.py \
243         lib/confd/client.py \
244         lib/confd/querylib.py \
245         lib/confd/server.py
246
247 masterd_PYTHON = \
248         lib/masterd/__init__.py \
249         lib/masterd/instance.py
250
251 impexpd_PYTHON = \
252         lib/impexpd/__init__.py
253
254 watcher_PYTHON = \
255         lib/watcher/__init__.py \
256         lib/watcher/nodemaint.py \
257         lib/watcher/state.py
258
259 server_PYTHON = \
260         lib/server/__init__.py \
261         lib/server/confd.py \
262         lib/server/masterd.py \
263         lib/server/noded.py \
264         lib/server/rapi.py
265
266 pytools_PYTHON = \
267         lib/tools/__init__.py \
268         lib/tools/ensure_dirs.py
269
270 utils_PYTHON = \
271         lib/utils/__init__.py \
272         lib/utils/algo.py \
273         lib/utils/filelock.py \
274         lib/utils/hash.py \
275         lib/utils/io.py \
276         lib/utils/log.py \
277         lib/utils/mlock.py \
278         lib/utils/nodesetup.py \
279         lib/utils/process.py \
280         lib/utils/retry.py \
281         lib/utils/text.py \
282         lib/utils/wrapper.py \
283         lib/utils/x509.py
284
285 docrst = \
286         doc/admin.rst \
287         doc/design-2.0.rst \
288         doc/design-2.1.rst \
289         doc/design-2.2.rst \
290         doc/design-2.3.rst \
291         doc/design-htools-2.3.rst \
292         doc/design-2.4.rst \
293         doc/design-2.5.rst \
294         doc/design-draft.rst \
295         doc/design-oob.rst \
296         doc/design-cpu-pinning.rst \
297         doc/design-query2.rst \
298         doc/design-x509-ca.rst \
299         doc/design-http-server.rst \
300         doc/design-impexp2.rst \
301         doc/design-lu-generated-jobs.rst \
302         doc/design-multi-reloc.rst \
303         doc/design-network.rst \
304         doc/design-chained-jobs.rst \
305         doc/design-ovf-support.rst \
306         doc/cluster-merge.rst \
307         doc/design-shared-storage.rst \
308         doc/devnotes.rst \
309         doc/glossary.rst \
310         doc/hooks.rst \
311         doc/iallocator.rst \
312         doc/index.rst \
313         doc/install-quick.rst \
314         doc/install.rst \
315         doc/locking.rst \
316         doc/move-instance.rst \
317         doc/news.rst \
318         doc/rapi.rst \
319         doc/security.rst \
320         doc/upgrade.rst \
321         doc/walkthrough.rst
322
323 HS_PROGS = htools/htools
324 HS_BIN_ROLES = hbal hscan hspace
325
326 HS_ALL_PROGS = $(HS_PROGS) htools/test
327 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
328 # we don't add -Werror by default
329 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
330 # extra flags that can be overriden on the command line
331 HEXTRA =
332 # exclude options for coverage reports
333 HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC \
334         --exclude Ganeti.Constants \
335         --exclude Ganeti.HTools.Version
336
337 HS_LIB_SRCS = \
338         htools/Ganeti/HTools/CLI.hs \
339         htools/Ganeti/HTools/Cluster.hs \
340         htools/Ganeti/HTools/Compat.hs \
341         htools/Ganeti/HTools/Container.hs \
342         htools/Ganeti/HTools/ExtLoader.hs \
343         htools/Ganeti/HTools/Group.hs \
344         htools/Ganeti/HTools/IAlloc.hs \
345         htools/Ganeti/HTools/Instance.hs \
346         htools/Ganeti/HTools/Loader.hs \
347         htools/Ganeti/HTools/Luxi.hs \
348         htools/Ganeti/HTools/Node.hs \
349         htools/Ganeti/HTools/PeerMap.hs \
350         htools/Ganeti/HTools/QC.hs \
351         htools/Ganeti/HTools/Rapi.hs \
352         htools/Ganeti/HTools/Simu.hs \
353         htools/Ganeti/HTools/Text.hs \
354         htools/Ganeti/HTools/Types.hs \
355         htools/Ganeti/HTools/Utils.hs \
356         htools/Ganeti/HTools/Program/Hail.hs \
357         htools/Ganeti/HTools/Program/Hbal.hs \
358         htools/Ganeti/HTools/Program/Hscan.hs \
359         htools/Ganeti/HTools/Program/Hspace.hs \
360         htools/Ganeti/Jobs.hs \
361         htools/Ganeti/Luxi.hs \
362         htools/Ganeti/OpCodes.hs
363
364 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
365 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
366
367 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
368
369 # Note: we use here an order-only prerequisite, as the contents of
370 # _autoconf.py are not actually influencing the html build output: it
371 # has to exist in order for the sphinx module to be loaded
372 # successfully, but we certainly don't want the docs to be rebuilt if
373 # it changes
374 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
375         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
376         | $(BUILT_PYTHON_SOURCES)
377         @test -n "$(SPHINX)" || \
378             { echo 'sphinx-build' not found during configure; exit 1; }
379         @mkdir_p@ $(dir $@)
380         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
381             -d . \
382             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
383             -D release="$(PACKAGE_VERSION)" \
384             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
385         rm -f doc/html/.buildinfo doc/html/objects.inv
386         touch $@
387
388 doc/html: doc/html/index.html
389
390 doc/install-quick.rst: INSTALL
391 doc/news.rst: NEWS
392 doc/upgrade.rst: UPGRADE
393
394 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
395         set -e; \
396         { echo '.. This file is automatically updated at build time from $<.'; \
397           echo '.. Do not edit.'; \
398           echo; \
399           cat $<; \
400         } > $@
401
402 docdot = \
403         doc/arch-2.0.dot \
404         doc/design-2.1-lock-acquire.dot \
405         doc/design-2.1-lock-release.dot
406
407 docpng = $(patsubst %.dot,%.png,$(docdot))
408
409 # Things to build but not to install (add it to EXTRA_DIST if it should be
410 # distributed)
411 noinst_DATA = \
412         devel/upload \
413         doc/html \
414         doc/examples/bash_completion \
415         doc/examples/ganeti.cron \
416         doc/examples/ganeti.initd \
417         doc/examples/ganeti-kvm-poweroff.initd \
418         doc/examples/gnt-config-backup \
419         doc/examples/hooks/ipsec \
420         $(manhtml)
421
422 gnt_scripts = \
423         scripts/gnt-backup \
424         scripts/gnt-cluster \
425         scripts/gnt-debug \
426         scripts/gnt-group \
427         scripts/gnt-instance \
428         scripts/gnt-job \
429         scripts/gnt-node \
430         scripts/gnt-os
431
432 PYTHON_BOOTSTRAP_SBIN = \
433         daemons/ganeti-confd \
434         daemons/ganeti-masterd \
435         daemons/ganeti-noded \
436         daemons/ganeti-watcher \
437         daemons/ganeti-rapi \
438         scripts/gnt-backup \
439         scripts/gnt-cluster \
440         scripts/gnt-debug \
441         scripts/gnt-group \
442         scripts/gnt-instance \
443         scripts/gnt-job \
444         scripts/gnt-node \
445         scripts/gnt-os
446
447 PYTHON_BOOTSTRAP = \
448         $(PYTHON_BOOTSTRAP_SBIN) \
449         tools/ensure-dirs
450
451 qa_scripts = \
452         qa/ganeti-qa.py \
453         qa/qa_cluster.py \
454         qa/qa_config.py \
455         qa/qa_daemon.py \
456         qa/qa_env.py \
457         qa/qa_error.py \
458         qa/qa_group.py \
459         qa/qa_instance.py \
460         qa/qa_node.py \
461         qa/qa_os.py \
462         qa/qa_rapi.py \
463         qa/qa_tags.py \
464         qa/qa_utils.py
465
466 bin_SCRIPTS =
467 if WANT_HTOOLS
468 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
469 install-exec-hook:
470         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
471 # FIXME: this is a hardcoded logic, instead of auto-resolving
472         $(LN_S) -f ../../../bin/htools \
473                    $(DESTDIR)$(iallocatorsdir)/hail
474         for role in $(HS_BIN_ROLES); do \
475                 $(LN_S) -f htools \
476                            $(DESTDIR)$(bindir)/$$role ; \
477         done
478 endif
479
480 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
481         @if [ -z "$(HTOOLS)" ]; then \
482           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
483           exit 1; \
484         fi
485         @BINARY=$(@:htools/%=%); \
486         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
487           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
488           exit 1; \
489         fi
490         BINARY=$(@:htools/%=%); $(GHC) --make \
491           $(HFLAGS) $(HEXTRA) \
492           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
493           -osuf $$BINARY.o -hisuf $$BINARY.hi $@
494
495 # for the htools/test binary, we need to enable profiling/coverage
496 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
497         -fno-warn-monomorphism-restriction -fno-warn-orphans \
498         -fno-warn-missing-methods -fno-warn-unused-imports
499
500 dist_sbin_SCRIPTS = \
501         tools/ganeti-listrunner
502
503 nodist_sbin_SCRIPTS = \
504         $(PYTHON_BOOTSTRAP_SBIN) \
505         daemons/ganeti-cleaner
506
507 python_scripts = \
508         tools/burnin \
509         tools/cfgshell \
510         tools/cfgupgrade \
511         tools/cfgupgrade12 \
512         tools/cluster-merge \
513         tools/lvmstrap \
514         tools/move-instance \
515         tools/setup-ssh \
516         tools/sanitize-config
517
518 dist_tools_SCRIPTS = \
519         $(python_scripts) \
520         tools/kvm-console-wrapper \
521         tools/xm-console-wrapper
522
523 pkglib_python_scripts = \
524         daemons/import-export \
525         tools/check-cert-expired
526
527 nodist_pkglib_python_scripts = \
528         tools/ensure-dirs
529
530 myexeclib_SCRIPTS = \
531         daemons/daemon-util \
532         tools/kvm-ifup \
533         $(pkglib_python_scripts)
534
535 nodist_myexeclib_SCRIPTS = \
536         $(nodist_pkglib_python_scripts)
537
538 EXTRA_DIST = \
539         NEWS \
540         UPGRADE \
541         epydoc.conf.in \
542         pylintrc \
543         autotools/build-bash-completion \
544         autotools/check-python-code \
545         autotools/check-man \
546         autotools/check-news \
547         autotools/check-tar \
548         autotools/check-version \
549         autotools/convert-constants \
550         autotools/docpp \
551         autotools/gen-coverage \
552         autotools/testrunner \
553         $(RUN_IN_TEMPDIR) \
554         daemons/daemon-util.in \
555         daemons/ganeti-cleaner.in \
556         $(pkglib_python_scripts) \
557         devel/upload.in \
558         tools/kvm-ifup.in \
559         $(docdot) \
560         $(docpng) \
561         $(docrst) \
562         doc/conf.py \
563         doc/html \
564         doc/examples/ganeti.initd.in \
565         doc/examples/ganeti-kvm-poweroff.initd.in \
566         doc/examples/ganeti.cron.in \
567         doc/examples/gnt-config-backup.in \
568         doc/examples/ganeti.default \
569         doc/examples/ganeti.default-debug \
570         doc/examples/hooks/ethers \
571         doc/examples/hooks/ipsec.in \
572         doc/examples/gnt-debug/README \
573         doc/examples/gnt-debug/delay0.json \
574         doc/examples/gnt-debug/delay50.json \
575         test/testutils.py \
576         test/mocks.py \
577         $(dist_TESTS) \
578         $(TEST_FILES) \
579         man/footer.rst \
580         $(manrst) \
581         $(maninput) \
582         qa/qa-sample.json \
583         $(qa_scripts) \
584         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
585         $(HS_PROG_SRCS)
586
587 man_MANS = \
588         man/ganeti.7 \
589         man/ganeti-cleaner.8 \
590         man/ganeti-confd.8 \
591         man/ganeti-listrunner.8 \
592         man/ganeti-masterd.8 \
593         man/ganeti-noded.8 \
594         man/ganeti-os-interface.7 \
595         man/ganeti-rapi.8 \
596         man/ganeti-watcher.8 \
597         man/gnt-backup.8 \
598         man/gnt-cluster.8 \
599         man/gnt-debug.8 \
600         man/gnt-group.8 \
601         man/gnt-instance.8 \
602         man/gnt-job.8 \
603         man/gnt-node.8 \
604         man/gnt-os.8 \
605         man/hail.1 \
606         man/hbal.1 \
607         man/hscan.1 \
608         man/hspace.1 \
609         man/htools.1
610
611 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
612 manhtml = $(patsubst %.rst,%.html,$(manrst))
613 mangen = $(patsubst %.rst,%.gen,$(manrst))
614 maninput = \
615         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
616         $(patsubst %.html,%.html.in,$(manhtml)) \
617         man/footer.man man/footer.html $(mangen)
618
619 TEST_FILES = \
620         test/data/bdev-drbd-8.0.txt \
621         test/data/bdev-drbd-8.3.txt \
622         test/data/bdev-drbd-disk.txt \
623         test/data/bdev-drbd-net-ip4.txt \
624         test/data/bdev-drbd-net-ip6.txt \
625         test/data/cert1.pem \
626         test/data/ip-addr-show-dummy0.txt \
627         test/data/ip-addr-show-lo-ipv4.txt \
628         test/data/ip-addr-show-lo-ipv6.txt \
629         test/data/ip-addr-show-lo-oneline-ipv4.txt \
630         test/data/ip-addr-show-lo-oneline-ipv6.txt \
631         test/data/ip-addr-show-lo-oneline.txt \
632         test/data/ip-addr-show-lo.txt \
633         test/data/proc_drbd8.txt \
634         test/data/proc_drbd80-emptyline.txt \
635         test/data/proc_drbd83.txt \
636         test/data/proc_drbd83_sync.txt \
637         test/data/proc_drbd83_sync_krnl2.6.39.txt \
638         test/data/kvm_1.0_help.txt \
639         test/data/kvm_0.15.90_help.txt \
640         test/data/kvm_0.12.5_help.txt \
641         test/data/kvm_0.9.1_help.txt \
642         test/data/sys_drbd_usermode_helper.txt \
643         test/import-export_unittest-helper
644
645 python_tests = \
646         test/ganeti.asyncnotifier_unittest.py \
647         test/ganeti.backend_unittest.py \
648         test/ganeti.bdev_unittest.py \
649         test/ganeti.cli_unittest.py \
650         test/ganeti.client.gnt_cluster_unittest.py \
651         test/ganeti.client.gnt_instance_unittest.py \
652         test/ganeti.daemon_unittest.py \
653         test/ganeti.cmdlib_unittest.py \
654         test/ganeti.compat_unittest.py \
655         test/ganeti.confd.client_unittest.py \
656         test/ganeti.config_unittest.py \
657         test/ganeti.constants_unittest.py \
658         test/ganeti.errors_unittest.py \
659         test/ganeti.hooks_unittest.py \
660         test/ganeti.ht_unittest.py \
661         test/ganeti.http_unittest.py \
662         test/ganeti.hypervisor_unittest.py \
663         test/ganeti.hypervisor.hv_chroot_unittest.py \
664         test/ganeti.hypervisor.hv_fake_unittest.py \
665         test/ganeti.hypervisor.hv_kvm_unittest.py \
666         test/ganeti.hypervisor.hv_lxc_unittest.py \
667         test/ganeti.hypervisor.hv_xen_unittest.py \
668         test/ganeti.impexpd_unittest.py \
669         test/ganeti.jqueue_unittest.py \
670         test/ganeti.locking_unittest.py \
671         test/ganeti.luxi_unittest.py \
672         test/ganeti.masterd.instance_unittest.py \
673         test/ganeti.mcpu_unittest.py \
674         test/ganeti.netutils_unittest.py \
675         test/ganeti.objects_unittest.py \
676         test/ganeti.opcodes_unittest.py \
677         test/ganeti.qlang_unittest.py \
678         test/ganeti.query_unittest.py \
679         test/ganeti.rapi.baserlib_unittest.py \
680         test/ganeti.rapi.client_unittest.py \
681         test/ganeti.rapi.resources_unittest.py \
682         test/ganeti.rapi.rlib2_unittest.py \
683         test/ganeti.rpc_unittest.py \
684         test/ganeti.runtime_unittest.py \
685         test/ganeti.serializer_unittest.py \
686         test/ganeti.ssh_unittest.py \
687         test/ganeti.storage_unittest.py \
688         test/ganeti.tools.ensure_dirs_unittest.py \
689         test/ganeti.uidpool_unittest.py \
690         test/ganeti.utils.algo_unittest.py \
691         test/ganeti.utils.filelock_unittest.py \
692         test/ganeti.utils.hash_unittest.py \
693         test/ganeti.utils.io_unittest.py \
694         test/ganeti.utils.log_unittest.py \
695         test/ganeti.utils.mlock_unittest.py \
696         test/ganeti.utils.nodesetup_unittest.py \
697         test/ganeti.utils.process_unittest.py \
698         test/ganeti.utils.retry_unittest.py \
699         test/ganeti.utils.text_unittest.py \
700         test/ganeti.utils.wrapper_unittest.py \
701         test/ganeti.utils.x509_unittest.py \
702         test/ganeti.utils_unittest.py \
703         test/ganeti.workerpool_unittest.py \
704         test/cfgupgrade_unittest.py \
705         test/docs_unittest.py \
706         test/tempfile_fork_unittest.py
707
708 haskell_tests = htools/test
709
710 dist_TESTS = \
711         test/check-cert-expired_unittest.bash \
712         test/daemon-util_unittest.bash \
713         test/ganeti-cleaner_unittest.bash \
714         test/import-export_unittest.bash \
715         $(python_tests)
716
717 nodist_TESTS =
718 if WANT_HTOOLSTESTS
719 nodist_TESTS += $(haskell_tests)
720 endif
721
722 TESTS = $(dist_TESTS) $(nodist_TESTS)
723
724 # Environment for all tests
725 PLAIN_TESTS_ENVIRONMENT = \
726         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
727
728 # Environment for tests run by automake
729 TESTS_ENVIRONMENT = \
730         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
731
732 all_python_code = \
733         $(dist_sbin_SCRIPTS) \
734         $(python_scripts) \
735         $(pkglib_python_scripts) \
736         $(nodist_pkglib_python_scripts) \
737         $(python_tests) \
738         $(pkgpython_PYTHON) \
739         $(client_PYTHON) \
740         $(hypervisor_PYTHON) \
741         $(rapi_PYTHON) \
742         $(server_PYTHON) \
743         $(pytools_PYTHON) \
744         $(http_PYTHON) \
745         $(confd_PYTHON) \
746         $(masterd_PYTHON) \
747         $(impexpd_PYTHON) \
748         $(utils_PYTHON) \
749         $(watcher_PYTHON) \
750         $(noinst_PYTHON) \
751         $(qa_scripts)
752
753 srclink_files = \
754         man/footer.rst \
755         test/check-cert-expired_unittest.bash \
756         test/daemon-util_unittest.bash \
757         test/ganeti-cleaner_unittest.bash \
758         test/import-export_unittest.bash \
759         $(all_python_code) \
760         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
761
762 check_python_code = \
763         $(BUILD_BASH_COMPLETION) \
764         $(DOCPP) \
765         $(all_python_code)
766
767 lint_python_code = \
768         ganeti \
769         ganeti/http/server.py \
770         $(dist_sbin_SCRIPTS) \
771         $(python_scripts) \
772         $(pkglib_python_scripts) \
773         $(BUILD_BASH_COMPLETION) \
774         $(DOCPP) \
775         $(PYTHON_BOOTSTRAP)
776
777 pep8_python_code = \
778         ganeti \
779         ganeti/http/server.py \
780         $(dist_sbin_SCRIPTS) \
781         $(python_scripts) \
782         $(pkglib_python_scripts) \
783         $(BUILD_BASH_COMPLETION) \
784         $(DOCPP) \
785         $(PYTHON_BOOTSTRAP) \
786         qa
787
788 test/daemon-util_unittest.bash: daemons/daemon-util
789
790 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
791
792 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
793         sed -f $(REPLACE_VARS_SED) < $< > $@
794         chmod +x $@
795
796 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
797         sed -f $(REPLACE_VARS_SED) < $< > $@
798         chmod u+x $@
799
800 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
801         sed -f $(REPLACE_VARS_SED) < $< > $@
802         chmod +x $@
803
804 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
805         sed -f $(REPLACE_VARS_SED) < $< > $@
806
807 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
808         sed -f $(REPLACE_VARS_SED) < $< > $@
809
810 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
811         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
812         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
813
814 doc/%.png: doc/%.dot
815         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
816         $(DOT) -Tpng -o $@ $<
817
818 man/footer.man: man/footer.rst
819         @test -n "$(PANDOC)" || \
820           { echo 'pandoc' not found during configure; exit 1; }
821         $(PANDOC) -f rst -t man -o $@ $<
822
823 man/footer.html: man/footer.rst
824         @test -n "$(PANDOC)" || \
825           { echo 'pandoc' not found during configure; exit 1; }
826         $(PANDOC) -f rst -t html -o $@ $<
827
828 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
829         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
830
831 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
832         @test -n "$(PANDOC)" || \
833           { echo 'pandoc' not found during configure; exit 1; }
834         set -o pipefail ; \
835         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
836           sed -e 's/\\@/@/g' > $@
837         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
838
839 man/%.html.in: man/%.gen man/footer.html
840         @test -n "$(PANDOC)" || \
841           { echo 'pandoc' not found during configure; exit 1; }
842         set -o pipefail ; \
843         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
844           sed -e 's/\\@/@/g' > $@
845
846 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
847         sed -f $(REPLACE_VARS_SED) < $< > $@
848
849 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
850         sed -f $(REPLACE_VARS_SED) < $< > $@
851
852 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
853         sed -f $(REPLACE_VARS_SED) < $< > $@
854
855 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
856         sed -f $(REPLACE_VARS_SED) < $< > $@
857
858 epydoc.conf: epydoc.conf.in Makefile
859         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
860
861 vcs-version:
862         if test -d .git; then \
863           git describe > $@; \
864         elif test ! -f $@ ; then \
865           echo "Cannot auto-generate $@ file"; exit 1; \
866         fi
867
868 .PHONY: regen-vcs-version
869 regen-vcs-version:
870         set -e; \
871         cd $(srcdir); \
872         if test -d .git; then \
873           rm -f vcs-version; \
874           $(MAKE) vcs-version; \
875         fi
876
877 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
878         set -e; \
879         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
880         sed -e "s/%ver%/$$VCSVER/" < $< > $@
881
882 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
883         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS)
884         set -e; \
885         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
886
887 lib/_autoconf.py: Makefile | lib/.dir
888         set -e; \
889         { echo '# This file is automatically generated, do not edit!'; \
890           echo '#'; \
891           echo ''; \
892           echo '"""Build-time configuration for Ganeti.'; \
893           echo '';\
894           echo 'This file is autogenerated by the build process.'; \
895           echo 'For any changes you need to re-run ./configure (and'; \
896           echo 'not edit by hand).'; \
897           echo ''; \
898           echo '"""'; \
899           echo ''; \
900           echo '# pylint: disable-msg=C0301,C0324'; \
901           echo '# because this is autogenerated, we do not want'; \
902           echo '# style warnings' ; \
903           echo ''; \
904           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
905           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
906           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
907           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
908           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
909           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
910           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
911           echo "SYSCONFDIR = '$(sysconfdir)'"; \
912           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
913           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
914           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
915           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
916           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
917           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
918           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
919           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
920           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
921           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
922           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
923           echo "KVM_PATH = '$(KVM_PATH)'"; \
924           echo "IP_PATH = '$(IP_PATH)'"; \
925           echo "SOCAT_PATH = '$(SOCAT)'"; \
926           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
927           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
928           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
929           echo "TOOLSDIR = '$(toolsdir)'"; \
930           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
931           echo "PKGLIBDIR = '$(pkglibdir)'"; \
932           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
933           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
934           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
935           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
936           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
937           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
938           echo "RAPI_USER = '$(RAPI_USER)'"; \
939           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
940           echo "CONFD_USER = '$(CONFD_USER)'"; \
941           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
942           echo "NODED_USER = '$(NODED_USER)'"; \
943           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
944           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
945           if [ "$(HTOOLS)" ]; then \
946             echo "HTOOLS = True"; \
947           else \
948             echo "HTOOLS = False"; \
949           fi; \
950         } > $@
951
952 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
953         set -e; \
954         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
955         { echo '# This file is automatically generated, do not edit!'; \
956           echo '#'; \
957           echo ''; \
958           echo '"""Build-time VCS version number for Ganeti.'; \
959           echo '';\
960           echo 'This file is autogenerated by the build process.'; \
961           echo 'For any changes you need to re-run ./configure (and'; \
962           echo 'not edit by hand).'; \
963           echo ''; \
964           echo '"""'; \
965           echo ''; \
966           echo '# pylint: disable-msg=C0301,C0324'; \
967           echo '# because this is autogenerated, we do not want'; \
968           echo '# style warnings' ; \
969           echo ''; \
970           echo "VCS_VERSION = '$$VCSVER'"; \
971         } > $@
972
973 $(REPLACE_VARS_SED): Makefile
974         set -e; \
975         { echo 's#@PREFIX@#$(prefix)#g'; \
976           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
977           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
978           echo 's#@BINDIR@#$(bindir)#g'; \
979           echo 's#@SBINDIR@#$(sbindir)#g'; \
980           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
981           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
982           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
983           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
984           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
985           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
986           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
987           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
988           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
989           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
990           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
991           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
992           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
993           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
994           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
995           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
996           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
997           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
998         } > $@
999
1000 # Using deferred evaluation
1001 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1002 daemons/ganeti-watcher: MODULE = ganeti.watcher
1003 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1004 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1005
1006 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1007         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1008         set -e; \
1009         { echo '#!/usr/bin/python'; \
1010           echo '# This file is automatically generated, do not edit!'; \
1011           echo "# Edit $(MODULE) instead."; \
1012           echo; \
1013           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1014           echo; \
1015           echo '# pylint: disable-msg=C0103'; \
1016           echo '# C0103: Invalid name'; \
1017           echo; \
1018           echo 'import sys'; \
1019           echo 'import $(MODULE) as main'; \
1020           echo; \
1021           echo '# Temporarily alias commands until bash completion'; \
1022           echo '# generator is changed'; \
1023           echo 'if hasattr(main, "commands"):'; \
1024           echo '  commands = main.commands # pylint: disable-msg=E1101'; \
1025           echo 'if hasattr(main, "aliases"):'; \
1026           echo '  aliases = main.aliases # pylint: disable-msg=E1101'; \
1027           echo; \
1028           echo 'if __name__ == "__main__":'; \
1029           echo '  sys.exit(main.Main())'; \
1030         } > $@
1031         chmod u+x $@
1032
1033 # We need to create symlinks because "make distcheck" will not install Python
1034 # files when building.
1035 stamp-srclinks: Makefile | $(all_dirfiles)
1036         set -e; \
1037         for i in $(srclink_files); do \
1038                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1039                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1040                 fi; \
1041         done
1042         touch $@
1043
1044 .PHONY: ganeti
1045 ganeti:
1046         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1047
1048 .PHONY: check-dirs
1049 check-dirs: $(BUILT_SOURCES)
1050         @set -e; \
1051         find . -type d \( \( -name . \) -o \( \
1052                 -name .git -o \
1053                 -name autom4te.cache \
1054                 \) -prune -o -print \) | { \
1055                 error=; \
1056                 while read dir; do \
1057                         case "$$dir" in \
1058                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1059                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1060                         esac; \
1061                 done; \
1062                 for dir in $(DIRS); do \
1063                         if ! test -d "$$dir"; then \
1064                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1065                                 error=1; \
1066                         fi \
1067                 done; \
1068                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1069         }
1070
1071 check-local: check-dirs
1072         $(CHECK_PYTHON_CODE) $(check_python_code)
1073         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1074         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1075         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1076         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1077                 echo "Incorrect version in README, expected $$expver"; \
1078                 exit 1; \
1079         fi; \
1080         for file in doc/iallocator.rst doc/hooks.rst; do \
1081                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1082                         "Documents Ganeti version $$expver"; then \
1083                         echo "Incorrect version in $$file, expected $$expver"; \
1084                         exit 1; \
1085                 fi; \
1086         done
1087
1088 .PHONY: hs-check
1089 hs-check: htools/test
1090         @rm -f test.tix
1091         ./htools/test
1092
1093 # E111: indentation is not a multiple of four
1094 # E261: at least two spaces before inline comment
1095 # E501: line too long (80 characters)
1096 PEP8_IGNORE = E111,E261,E501
1097
1098 # For excluding pep8 expects filenames only, not whole paths
1099 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1100
1101 .PHONY: lint
1102 lint: $(BUILT_SOURCES)
1103         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1104         if test -z "$(PEP8)"; then \
1105                 echo '"pep8" not found during configure' >&2; \
1106         else \
1107                 $(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1108                         $(pep8_python_code); \
1109         fi
1110         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1111         cd $(top_srcdir)/qa && \
1112           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1113           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1114
1115 .PHONY: hlint
1116 hlint: $(HS_BUILT_SRCS)
1117         if tty -s; then C="-c"; else C=""; fi; \
1118         hlint --report=doc/hs-lint.html $$C htools
1119
1120 # a dist hook rule for updating the vcs-version file; this is
1121 # hardcoded due to where it needs to build the file...
1122 dist-hook:
1123         $(MAKE) regen-vcs-version && \
1124         rm -f $(top_distdir)/vcs-version && \
1125         cp -p $(srcdir)/vcs-version $(top_distdir)
1126
1127 # a distcheck hook rule for catching revision control directories
1128 distcheck-hook:
1129         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1130                 echo "Found revision control files in final archive." 1>&2; \
1131                 exit 1; \
1132         fi
1133         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1134                 echo "Found Python byte code in final archive." 1>&2; \
1135                 exit 1; \
1136         fi
1137         if find $(top_distdir) -name '*~' | grep .; then \
1138                 echo "Found backup files in final archive." 1>&2; \
1139                 exit 1; \
1140         fi
1141 # Empty files or directories should not be distributed. They can cause
1142 # unnecessary warnings for packagers. Directories used by automake during
1143 # distcheck must be excluded.
1144         if find $(top_distdir) -empty -and -not \( \
1145                         -path $(top_distdir)/_build -or \
1146                         -path $(top_distdir)/_inst \) | grep .; then \
1147                 echo "Found empty files or directories in final archive." 1>&2; \
1148                 exit 1; \
1149         fi
1150         if test -n "$(BUILD_RELEASE)" && \
1151            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1152                 echo "Found unreleased version in NEWS." >&2; \
1153                 exit 1; \
1154         fi
1155
1156 # When building a release, stricter checks should be used
1157 distcheck-release dist-release: export BUILD_RELEASE = 1
1158 distcheck-release: distcheck
1159
1160 dist-release: dist
1161         set -e; \
1162         for i in $(DIST_ARCHIVES); do \
1163                 echo -n "Checking $$i ... "; \
1164                 autotools/check-tar < $$i; \
1165                 echo OK; \
1166         done
1167
1168 install-exec-local:
1169         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1170           "$(DESTDIR)${localstatedir}/log/ganeti" \
1171           "$(DESTDIR)${localstatedir}/run/ganeti"
1172
1173 # To avoid conflicts between directory names and other targets, a file inside
1174 # the directory is used to ensure its existence.
1175 %.dir:
1176         @mkdir_p@ $* && touch $@
1177
1178 .PHONY: apidoc
1179 if WANT_HTOOLSAPIDOC
1180 apidoc: py-apidoc hs-apidoc
1181 else
1182 apidoc: py-apidoc
1183 endif
1184
1185 .PHONY: py-apidoc
1186 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1187         $(RUN_IN_TEMPDIR) epydoc -v \
1188                 --conf $(CURDIR)/epydoc.conf \
1189                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1190
1191 .PHONY: hs-apidoc
1192 hs-apidoc: $(HS_BUILT_SRCS)
1193         @test -n "$(HSCOLOUR)" || \
1194             { echo 'HsColour' not found during configure; exit 1; }
1195         @test -n "$(HADDOCK)" || \
1196             { echo 'haddock' not found during configure; exit 1; }
1197         rm -rf $(APIDOC_HS_DIR)/*
1198         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1199         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1200         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1201         set -e ; \
1202         cd htools; \
1203         if [ "$(HTOOLS_NOCURL)" ]; \
1204         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1205         else OPTGHC=""; \
1206         fi; \
1207         if [ "$(HTOOLS_PARALLEL3)" ]; \
1208         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1209         fi; \
1210         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1211         for file in $$RELSRCS; do \
1212                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1213                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1214         done ; \
1215         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1216                 -t ganeti-htools -p haddock-prologue \
1217                 --source-module="%{MODULE/.//}.html" \
1218                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1219                 $$OPTGHC \
1220                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1221
1222 .PHONY: TAGS
1223 TAGS: $(BUILT_SOURCES)
1224         rm -f TAGS
1225         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1226           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1227           -path './qa/*.py' | \
1228           etags -l python -
1229
1230 .PHONY: coverage
1231 if WANT_HTOOLS
1232 coverage: py-coverage hs-coverage
1233 else
1234 coverage: py-coverage
1235 endif
1236
1237 .PHONY: py-coverage
1238 py-coverage: $(BUILT_SOURCES) $(python_tests)
1239         set -e; \
1240         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1241         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1242         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1243         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1244         $(python_tests)
1245
1246 .PHONY: hs-coverage
1247 hs-coverage: $(haskell_tests)
1248         cd htools && rm -f *.tix *.mix && ./test
1249         @mkdir_p@ $(COVERAGE_HS_DIR)
1250         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1251         hpc report htools/test $(HPCEXCL)
1252         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1253
1254 # Special "kind-of-QA" target for htools, needs special setup (all
1255 # tools compiled with -fhpc)
1256 .PHONY: live-test
1257 live-test: all
1258         set -e ; \
1259         cd htools; \
1260         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1261         rm -f *.tix *.mix; \
1262         ./live-test.sh; \
1263         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1264           --output=live-test.tix ; \
1265         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1266         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1267                 --srcdir=.. $(HPCEXCL) ; \
1268         hpc report --srcdir=.. live-test $(HPCEXCL)
1269
1270 commit-check: distcheck lint apidoc
1271
1272 -include ./Makefile.local
1273
1274 # vim: set noet :